#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
#
###2004-0309 - Modded by catastrophe for use with Connview v.0.2
###2004-0319 - Modded by catastrophe for use with Connview v.0.3
###2004-0403 - Modded by catastrophe for use with Connview v.0.4
###2004-0505 - Modded by catastrophe for use with Connview v.0.5
###2004-0919 - Modded by catastrophe for use with Connview v.0.6
###2005-0616 - Modded by catastrophe for use with Connview v.0.7
###2007-0805 - Modded by catastrophe for use with Connview v.0.7+
# - Added rc.sysinit Tweak by BoHiCa to "Allieviate p2p Conntrack Constipation on SmoothWall2"
# - Added cutter.tgz, ehoiting modded version of cutter by Chris Lowth


# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

print "\nInstalling Connview v.0.7+, please wait...\n\n";

#if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.8")) {
#	print "Please remove Connview pack v.0.7\n ";
#	print "Note - Run uninstall.pl script.\n \n";
#	exit;
#}

if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.7")) {
	print "Please remove Connview pack v.0.7\n ";
	print "Note - Run uninstall.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.6")) {
	print "Please remove Connview pack v.0.6\n ";
	print "Note - Run uninstall-06.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.5")) {
	print "Please remove Connview pack v.0.5\n ";
	print "Note - Run uninstall-05.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.4")) {
	print "Please remove Connview pack v.0.4\n ";
	print "Note - Run uninstall-04.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.3")) {
	print "Please remove Connview pack v.0.3\n ";
	print "Note - Run uninstall-03.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.2")) {
	print "Please remove Connview pack v.0.2\n ";
	print "Note - Run uninstall-02.pl script.\n \n";
	exit;
}


# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	backupinstall ($file ,$wkdir ,$storebkp ,$moddir);
#	install ($file ,$wkdir ,$moddir);

my $bkp = '/var/smoothwall/mods/connview/backup';

my $mod = '/var/smoothwall/mods/connview/modfiles';

$dir = '/home/httpd/cgi-bin';
#&backupinstall ('connview.cgi' ,$dir ,$bkp ,$mod);
&install ('connview.cgi' ,$dir ,$mod);

$dir = '/home/httpd/html/help';
#&backupinstall ('connview.cgi.html.en' ,$dir ,$bkp ,$mod);
&install ('connview.cgi.html.en' ,$dir ,$mod);

$dir = '/usr/local/bin';
#&backupinstall ('conntrack-viewer.pl' ,$dir ,$bkp ,$mod);
&install ('conntrack-viewer-CAT.pl' ,$dir ,$mod);
#&backupinstall ('connviewhelper' ,$dir ,$bkp ,$mod);
&install ('connviewhelper' ,$dir ,$mod);

$dir = '/etc/rc.d';
#&backupinstall ('rc.sysinit' ,$dir ,$bkp ,$mod);
&backup ('rc.sysinit' ,$dir ,$bkp);


# remove these lines when the web UI interface is ready
open (FILE, ">/var/smoothwall/preferences/dummy") or system ("/bin/su nobody -c '/bin/mkdir /var/smoothwall/preferences'");
close (FILE);
system ("/bin/rm -f /var/smoothwall/preferences/dummy");

# uncomment these lines when the web UI interface is ready
#open (FILE, ">/var/smoothwall/preferences/dummy") or system ("/bin/mkdir /var/smoothwall/preferences");
#close (FILE);
#system ("/bin/rm -f /var/smoothwall/preferences/dummy");

# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

my $param = '/var/smoothwall/mods/connview/params';

&easymod ("/var/smoothwall/main/ui/alertboxes.en.pl", "$param/alertboxes.en.pl.07.s",'0',"$param/alertboxes.en.pl.07.r");

&easymod ("/var/smoothwall/langs/base.pl", "$param/base.pl.07.s",'0',"$param/base.pl.07.r");

&easymod ("/var/smoothwall/header.pl", "$param/header.pl.05.s",'0',"$param/header.pl.05.r");

&easymod ("/home/httpd/cgi-bin/.htaccess", "$param/htaccess.1.s",'3',"$param/htaccess.1.r");

&easymod ("/etc/rc.d/rc.sysinit", "$param/rc.sysinit.08.s",'1',"$param/rc.sysinit.08.r");   ### Allieviate p2p Conntrack Constipation on SmoothWall2 by BoHiCa
system 'echo 600 > /proc/sys/net/ipv4/netfilter/ip_conntrack_tcp_timeout_established';

# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #

system '/bin/ln -s /home/httpd/html/ui/assets/3.6/img/pagetitles/title-about.png /home/httpd/html/ui/assets/3.6/img/pagetitles/page-connview.png';

system 'tar zxvf /var/smoothwall/mods/connview/extra/cutter.tgz -C /usr/local/bin';   ### ehoiting modded version of cutter by Chris Lowth\
system 'cp -p /usr/local/bin/cutter.c /var/smoothwall/mods/connview/src';   # some clean up
system 'rm -f /usr/local/bin/cutter.c';   # some clean up


# # # #
# end #
# # # #

#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal

$version = '2.1';

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file ,$wkdir ,$storebkp ,$moddir);
#	backup ($file ,$wkdir ,$storebkp);
#	install ($file ,$wkdir ,$moddir);
#	uninstallrestore ($file ,$wkdir ,$storebkp);
#	uninstall ($file  ,$wkdir);
#
#	installed ($file, $string);
#
#	search for $string into $file => 1 found / 0 not found

sub backupinstall
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	my $moddir = $_[3];
#	system "/bin/cp -p $wkdir/$file $storebkp/$file";
#	system "/bin/cp $moddir/$file $wkdir/$file";
	system "/bin/cp -p $moddir/$file $wkdir/$file";
}

sub backup
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	system "/bin/cp -p $wkdir/$file $storebkp/$file";
}

sub install
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $moddir = $_[2];
	system "/bin/cp -p $moddir/$file $wkdir/$file";
}

sub uninstallrestore
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	system "/bin/cp -p $storebkp/$file $wkdir/$file";
#	system "/bin/rm -f $storebkp/$file";
}

sub uninstall
{
	my $file = $_[0];
	my $wkdir = $_[1];
	system "/bin/rm -f $wkdir/$file";
}

sub easymod
{
	my $targetfile = $_[0];
	my $searchfile = $_[1];
	my $linestodelete = $_[2];
	my $replacefile = $_[3];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	open(SEARCH, "$searchfile") or die 'Unable to open search file';
	my @search = <SEARCH>;
	close(SEARCH);

	open(REPLACE, "$replacefile") or die 'Unable to open replace file.';
	my @replace = <REPLACE>;
	close(REPLACE);

	open(TEMP, ">/tmp/temp") or die 'Unable to open temporary file.';
	flock TEMP, 2;

	my $found = 0;
	my $line;
	foreach $line (@target)
	{
		if ($found == 0)
		{
			if ($line eq "@search")
			{
				$found = 1;
				if ($linestodelete > 0)
				{
					$linestodelete--;
				}
				else {print TEMP "$line"; }
				my $repline;
				foreach $repline (@replace) {print TEMP $repline; }
			}
			else {print TEMP "$line"; }
		}
		else
		{
			if ($linestodelete > 0)
			{
				$linestodelete--;
			}
			else {print TEMP "$line"; }
		}
	}	
	close(TEMP);
	system "/bin/cp /tmp/temp $targetfile";
	system "/bin/rm -f /tmp/temp";
}

sub installed
{
	my $targetfile = $_[0];
	my $searchstring = $_[1];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	my $line;
	foreach $line (@target)
	{
		if ($line eq "$searchstring\n")
		{
			return 1;
		}
	}	
	return 0;
}
