#!/usr/bin/perl
#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal
#
###2004-0309 - Modded by catastrophe for use with Connview v.0.2
###2004-0319 - Modded by catastrophe for use with Connview v.0.3
###2004-0403 - Modded by catastrophe for use with Connview v.0.4
###2004-0505 - Modded by catastrophe for use with Connview v.0.5
###2004-0919 - Modded by catastrophe for use with Connview v.0.6
###2005-0616 - Modded by catastrophe for use with Connview v.0.7
###2007-0805 - Modded by catastrophe for use with Connview v.0.7+

# # # # # # # # # # # # # # # # # # #
# check for existing installations  #
# # # # # # # # # # # # # # # # # # #

print "\nUninstalling Connview v.0.7+, please wait...\n\n";

#if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.7")) {
#	print "Please remove Connview pack v.0.7\n ";
#	print "Note - Run uninstall-07.pl script.\n \n";
#	exit;
#}

if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.6")) {
	print "Please remove Connview pack v.0.6\n ";
	print "Note - Run uninstall-06.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.5")) {
	print "Please remove Connview pack v.0.5\n ";
	print "Note - Run uninstall-05.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.4")) {
	print "Please remove Connview pack v.0.4\n ";
	print "Note - Run uninstall-04.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.3")) {
	print "Please remove Connview pack v.0.3\n ";
	print "Note - Run uninstall-03.pl script.\n \n";
	exit;
}

if (&installed ("/var/smoothwall/langs/base.pl", "# connview v.0.2")) {
	print "Please remove Connview pack v.0.2\n ";
	print "Note - Run uninstall-02.pl script.\n \n";
	exit;
}

# # # # # # # # # # # #
# handle file copying #
# # # # # # # # # # # #

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file ,$wkdir ,$storebkp ,$moddir);
#	backup ($file ,$wkdir ,$storebkp);
#	install ($file ,$wkdir ,$moddir);
#	uninstallrestore ($file ,$wkdir ,$storebkp);
#	uninstall ($file  ,$wkdir);

my $bkp = '/var/smoothwall/mods/connview/backup';

my $mod = '/var/smoothwall/mods/connview/modfiles';

$dir = '/home/httpd/cgi-bin';
#&uninstallrestore ('connview.cgi' ,$dir ,$bkp);
&uninstall ('connview.cgi' ,$dir);

$dir = '/home/httpd/html/help';
#&uninstallrestore ('connview.cgi.html.en' ,$dir ,$bkp);
&uninstall ('connview.cgi.html.en' ,$dir);

$dir = '/usr/local/bin';
#&uninstallrestore ('conntrack-viewer.pl' ,$dir ,$bkp);
&uninstall ('conntrack-viewer-CAT.pl' ,$dir);
#&uninstallrestore ('connviewhelper' ,$dir ,$bkp);
&uninstall ('connviewhelper' ,$dir);
#&uninstallrestore ('cutter' ,$dir ,$bkp);
&uninstall ('cutter' ,$dir);

# # # # # # # # # # # #
# handle file editing #
# # # # # # # # # # # #

my $param = '/var/smoothwall/mods/connview/params';

&easymod ("/var/smoothwall/main/ui/alertboxes.en.pl", "$param/alertboxes.en.pl.07.d",'2',"/dev/null");

&easymod ("/var/smoothwall/langs/base.pl", "$param/base.pl.07.d",'22',"/dev/null");

&easymod ("/var/smoothwall/header.pl", "$param/header.pl.05.d",'1',"/dev/null");

&easymod ("/home/httpd/cgi-bin/.htaccess", "$param/htaccess.90.d",'3',"/dev/null");

&easymod ("/etc/rc.d/rc.sysinit", "$param/rc.sysinit.08.d",'2',"/dev/null");

# # # # # # # # # # # #
# handle file linking #
# # # # # # # # # # # #

system '/bin/rm -f /home/httpd/html/ui/assets/3.6/img/pagetitles/page-connview.png';

# # # #
# end #
# # # #

#
# This code is distributed under the terms of the GPL
#
# (c) Tiago Freitas Leal

$version = '2.1';

#	$storebkp =	where to store backup of the files that are changed by your mod
#	$moddir =	where your mod files are
#	$wkdir =	where you are changing files (backup from and copy to)
#
#	backupinstall ($file ,$wkdir ,$storebkp ,$moddir);
#	backup ($file ,$wkdir ,$storebkp);
#	install ($file ,$wkdir ,$moddir);
#	uninstallrestore ($file ,$wkdir ,$storebkp);
#	uninstall ($file  ,$wkdir);

sub backupinstall
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	my $moddir = $_[3];
#	system "/bin/cp -p $wkdir/$file $storebkp/$file";
#	system "/bin/cp $moddir/$file $wkdir/$file";
	system "/bin/cp -p $moddir/$file $wkdir/$file";
}

sub backup
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	system "/bin/cp -p $wkdir/$file $storebkp/$file";
}

sub install
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $moddir = $_[2];
	system "/bin/cp -p $moddir/$file $wkdir/$file";
}

sub uninstallrestore
{
	my $file = $_[0];
	my $wkdir = $_[1];
	my $storebkp = $_[2];
	system "/bin/cp -p $storebkp/$file $wkdir/$file";
#	system "/bin/rm -f $storebkp/$file";
}

sub uninstall
{
	my $file = $_[0];
	my $wkdir = $_[1];
	system "/bin/rm -f $wkdir/$file";
}

sub easymod
{
	my $targetfile = $_[0];
	my $searchfile = $_[1];
	my $linestodelete = $_[2];
	my $replacefile = $_[3];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	open(SEARCH, "$searchfile") or die 'Unable to open search file';
	my @search = <SEARCH>;
	close(SEARCH);

	open(REPLACE, "$replacefile") or die 'Unable to open replace file.';
	my @replace = <REPLACE>;
	close(REPLACE);

	open(TEMP, ">/tmp/temp") or die 'Unable to open temporary file.';
	flock TEMP, 2;

	my $found = 0;
	my $line;
	foreach $line (@target)
	{
		if ($found == 0)
		{
			if ($line eq "@search")
			{
				$found = 1;
				if ($linestodelete > 0)
				{
					$linestodelete--;
				}
				else {print TEMP "$line"; }
				my $repline;
				foreach $repline (@replace) {print TEMP $repline; }
			}
			else {print TEMP "$line"; }
		}
		else
		{
			if ($linestodelete > 0)
			{
				$linestodelete--;
			}
			else {print TEMP "$line"; }
		}
	}	
	close(TEMP);
	system "/bin/cp /tmp/temp $targetfile";
	system "/bin/rm -f /tmp/temp";
}

sub installed
{
	my $targetfile = $_[0];
	my $searchstring = $_[1];

	open(TARGET, "$targetfile") or die 'Unable to open target file.';
	my @target = <TARGET>;
	close(TARGET);

	my $line;
	foreach $line (@target)
	{
		if ($line eq "$searchstring\n")
		{
			return 1;
		}
	}	
	return 0;
}
